package org.openxma.dsl.generator.impl;

import java.util.Map;

import org.openxma.dsl.pom.model.XmadslPage;

import com.google.inject.ImplementedBy;

@ImplementedBy(ArquillianTestCaseGenerator.class)
public interface AutomationTestCaseGenerator {
    
    String getITCaseName(XmadslPage dslPage);
    
    CharSequence generateTestCase(XmadslPage dslPage, String namespace);

    String getPageObjectName(XmadslPage dslPage, boolean generated);
    
    CharSequence getPageObject(XmadslPage dslPage, String namespace);
    
    CharSequence getAbstractPageObject(XmadslPage dslPage, String namespace, Map<CharSequence, CharSequence> fieldNameMap);
}
