package org.openxma.dsl.generator.impl;

import java.util.Arrays;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.openxma.dsl.core.model.CondORExpr;
import org.openxma.dsl.core.model.EqualityExpr;
import org.openxma.dsl.core.model.EqualityOp;
import org.openxma.dsl.core.model.FalseLiteral;
import org.openxma.dsl.core.model.TrueLiteral;

@SuppressWarnings("all")
public class ExpressionLanguageImpl {
  protected CharSequence _getExpressionLanguage(final EqualityExpr it, final CharSequence defaultVal) {
    return defaultVal;
  }
  
  protected CharSequence _getExpressionLanguage(final FalseLiteral it, final CharSequence defaultVal) {
    return "false";
  }
  
  protected CharSequence _getExpressionLanguage(final TrueLiteral it, final CharSequence defaultVal) {
    return "true";
  }
  
  public CharSequence toExpressionLanguage(final EqualityExpr expr) {
    StringConcatenation _builder = new StringConcatenation();
    CondORExpr _left = expr.getLeft();
    _builder.append(_left, "");
    _builder.newLineIfNotEmpty();
    EqualityOp _op = expr.getOp();
    _builder.append(_op, "");
    _builder.newLineIfNotEmpty();
    CondORExpr _right = expr.getRight();
    _builder.append(_right, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence getExpressionLanguage(final EObject it, final CharSequence defaultVal) {
    if (it instanceof FalseLiteral) {
      return _getExpressionLanguage((FalseLiteral)it, defaultVal);
    } else if (it instanceof TrueLiteral) {
      return _getExpressionLanguage((TrueLiteral)it, defaultVal);
    } else if (it instanceof EqualityExpr) {
      return _getExpressionLanguage((EqualityExpr)it, defaultVal);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(it, defaultVal).toString());
    }
  }
}
