package org.openxma.dsl.generator.impl;

import com.google.common.base.Objects;
import com.google.inject.Inject;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.openxma.dsl.core.model.DataTypeAndTypeParameter;
import org.openxma.dsl.core.model.ValidatorReference;
import org.openxma.dsl.generator.impl.JsfData;
import org.openxma.dsl.generator.impl.JsfNames;
import org.openxma.dsl.generator.lib.ValidatorExtensions;
import org.openxma.dsl.pom.model.Combo;
import org.openxma.dsl.pom.model.CustomizeableField;
import org.openxma.dsl.pom.model.DataObjectVariable;
import org.openxma.dsl.pom.model.ListBox;
import org.openxma.dsl.pom.model.Table;
import org.openxma.dsl.pom.model.TableCombo;
import org.openxma.dsl.pom.model.Tree;
import org.openxma.dsl.pom.model.XmadslPage;

@SuppressWarnings("all")
public class FaceletDataImpl {
  @Inject
  private JsfNames jsfNames;
  
  @Inject
  private JsfData jsfData;
  
  public CharSequence createConverter(final DataTypeAndTypeParameter it) {
    CharSequence _xifexpression = null;
    ValidatorReference _validatorReferenceDefinition = it.getValidatorReferenceDefinition();
    boolean _equals = Objects.equal(_validatorReferenceDefinition, null);
    if (_equals) {
      StringConcatenation _builder = new StringConcatenation();
      _xifexpression = _builder;
    } else {
      CharSequence _xifexpression_1 = null;
      ValidatorReference _validatorReferenceDefinition_1 = it.getValidatorReferenceDefinition();
      boolean _isDateValidator = _validatorReferenceDefinition_1.isDateValidator();
      if (_isDateValidator) {
        StringConcatenation _builder_1 = new StringConcatenation();
        _builder_1.append("<f:convertDateTime pattern=\"dd.MM.yyyy\" />");
        _xifexpression_1 = _builder_1;
      } else {
        CharSequence _xifexpression_2 = null;
        ValidatorReference _validatorReferenceDefinition_2 = it.getValidatorReferenceDefinition();
        boolean _isNumberValidator = _validatorReferenceDefinition_2.isNumberValidator();
        if (_isNumberValidator) {
          StringConcatenation _builder_2 = new StringConcatenation();
          _builder_2.append("<f:convertNumber minFractionDigits=\"");
          Integer _scale = ValidatorExtensions.getScale(it);
          _builder_2.append(_scale, "");
          _builder_2.append("\" maxFractionDigits=\"");
          Integer _scale_1 = ValidatorExtensions.getScale(it);
          _builder_2.append(_scale_1, "");
          _builder_2.append("\" />");
          _xifexpression_2 = _builder_2;
        } else {
          CharSequence _xifexpression_3 = null;
          ValidatorReference _validatorReferenceDefinition_3 = it.getValidatorReferenceDefinition();
          boolean _isI18nValidator = _validatorReferenceDefinition_3.isI18nValidator();
          if (_isI18nValidator) {
            StringConcatenation _builder_3 = new StringConcatenation();
            _builder_3.append("<ui:remove>i18n should be displayed as combo, no converter needed</ui:remove>");
            _xifexpression_3 = _builder_3;
          } else {
            StringConcatenation _builder_4 = new StringConcatenation();
            _xifexpression_3 = _builder_4;
          }
          _xifexpression_2 = _xifexpression_3;
        }
        _xifexpression_1 = _xifexpression_2;
      }
      _xifexpression = _xifexpression_1;
    }
    return _xifexpression;
  }
  
  public CharSequence getListProperty(final TableCombo tableCombo) {
    StringConcatenation _builder = new StringConcatenation();
    DataObjectVariable _object = tableCombo.getObject();
    EObject _eContainer = _object.eContainer();
    CharSequence _referencedBean = this.jsfNames.referencedBean(_eContainer);
    _builder.append(_referencedBean, "");
    _builder.append(".");
    DataObjectVariable _object_1 = tableCombo.getObject();
    String _name = _object_1.getName();
    _builder.append(_name, "");
    return _builder;
  }
  
  public CharSequence getModelProperty(final Table table) {
    StringConcatenation _builder = new StringConcatenation();
    XmadslPage _parentPage = this.jsfNames.getParentPage(table);
    CharSequence _bean = this.jsfNames.getBean(_parentPage);
    _builder.append(_bean, "");
    _builder.append(".");
    CharSequence _modelPropertyName = this.jsfData.getModelPropertyName(table);
    _builder.append(_modelPropertyName, "");
    return _builder;
  }
  
  public CharSequence getRootNodeProperty(final Tree tree) {
    StringConcatenation _builder = new StringConcatenation();
    XmadslPage _parentPage = this.jsfNames.getParentPage(tree);
    CharSequence _bean = this.jsfNames.getBean(_parentPage);
    _builder.append(_bean, "");
    _builder.append(".");
    CharSequence _rootNodePropertyName = this.jsfData.getRootNodePropertyName(tree);
    _builder.append(_rootNodePropertyName, "");
    return _builder;
  }
  
  public CharSequence getSelectedNodeProperty(final Tree tree) {
    StringConcatenation _builder = new StringConcatenation();
    XmadslPage _parentPage = this.jsfNames.getParentPage(tree);
    CharSequence _bean = this.jsfNames.getBean(_parentPage);
    _builder.append(_bean, "");
    _builder.append(".");
    CharSequence _selectedNodePropertyName = this.jsfData.getSelectedNodePropertyName(tree);
    _builder.append(_selectedNodePropertyName, "");
    return _builder;
  }
  
  public CharSequence getSelectItemsProperty(final CustomizeableField field) {
    StringConcatenation _builder = new StringConcatenation();
    XmadslPage _parentPage = this.jsfNames.getParentPage(field);
    CharSequence _bean = this.jsfNames.getBean(_parentPage);
    _builder.append(_bean, "");
    _builder.append(".");
    CharSequence _selectItemsPropertyName = this.jsfData.getSelectItemsPropertyName(field);
    _builder.append(_selectItemsPropertyName, "");
    return _builder;
  }
  
  public CharSequence getSelectItemsProperty(final Combo combo) {
    StringConcatenation _builder = new StringConcatenation();
    XmadslPage _parentPage = this.jsfNames.getParentPage(combo);
    CharSequence _bean = this.jsfNames.getBean(_parentPage);
    _builder.append(_bean, "");
    _builder.append(".");
    CharSequence _selectItemsPropertyName = this.jsfData.getSelectItemsPropertyName(combo);
    _builder.append(_selectItemsPropertyName, "");
    return _builder;
  }
  
  public CharSequence getSelectItemsProperty(final ListBox listbox) {
    StringConcatenation _builder = new StringConcatenation();
    XmadslPage _parentPage = this.jsfNames.getParentPage(listbox);
    CharSequence _bean = this.jsfNames.getBean(_parentPage);
    _builder.append(_bean, "");
    _builder.append(".");
    CharSequence _selectItemsPropertyName = this.jsfData.getSelectItemsPropertyName(listbox);
    _builder.append(_selectItemsPropertyName, "");
    return _builder;
  }
  
  public CharSequence getSelectItemsProperty(final TableCombo combo) {
    StringConcatenation _builder = new StringConcatenation();
    XmadslPage _parentPage = this.jsfNames.getParentPage(combo);
    CharSequence _bean = this.jsfNames.getBean(_parentPage);
    _builder.append(_bean, "");
    _builder.append(".");
    CharSequence _selectItemsPropertyName = this.jsfData.getSelectItemsPropertyName(combo);
    _builder.append(_selectItemsPropertyName, "");
    return _builder;
  }
}
