package org.openxma.dsl.generator.impl;

import at.spardat.xma.guidesign.XMAComponent;
import java.util.Arrays;
import javax.inject.Inject;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.xbase.lib.StringExtensions;
import org.openxma.dsl.core.model.Model;
import org.openxma.dsl.generator.impl.Files;
import org.openxma.dsl.generator.impl.Types;
import org.openxma.dsl.pom.model.Component;
import org.openxma.dsl.pom.model.XmadslPage;

@SuppressWarnings("all")
public class FilesImpl implements Files {
  private String BACKING_BEAN_FOLDER = "backingbean";
  
  @Inject
  private Types types;
  
  public String packageFolderPath(final EObject eObject) {
    Model _model = this.types.model(eObject);
    String _name = _model==null?(String)null:_model.getName();
    String _replaceAll = _name.replaceAll("\\.", "/");
    return _replaceAll;
  }
  
  public String faceletPageFileName(final XmadslPage page, final boolean generated) {
    EObject _eContainer = page.eContainer();
    XMAComponent _xmaComponent = ((Component) _eContainer).getXmaComponent();
    String _namClass = _xmaComponent.getNamClass();
    String _plus = ("pages/" + _namClass);
    String _plus_1 = (_plus + "/");
    String _name = page.getName();
    String _firstLower = StringExtensions.toFirstLower(_name);
    String _plus_2 = (_plus_1 + _firstLower);
    String _xifexpression = null;
    if (generated) {
      _xifexpression = ".gen";
    } else {
      _xifexpression = "";
    }
    String _plus_3 = (_plus_2 + _xifexpression);
    String _plus_4 = (_plus_3 + ".xhtml");
    return _plus_4;
  }
  
  protected String _backingBeanFileName(final XmadslPage page, final boolean generated) {
    String _packageFolderPath = this.packageFolderPath(page);
    String _plus = (_packageFolderPath + "/");
    String _plus_1 = (_plus + this.BACKING_BEAN_FOLDER);
    String _plus_2 = (_plus_1 + "/");
    String _name = page.getName();
    String _plus_3 = (_plus_2 + _name);
    String _xifexpression = null;
    if (generated) {
      _xifexpression = "Gen";
    } else {
      _xifexpression = "";
    }
    String _plus_4 = (_plus_3 + _xifexpression);
    String _plus_5 = (_plus_4 + ".java");
    return _plus_5;
  }
  
  protected String _backingBeanFileName(final Component comp, final boolean generated) {
    String _packageFolderPath = this.packageFolderPath(comp);
    String _plus = (_packageFolderPath + "/");
    String _plus_1 = (_plus + this.BACKING_BEAN_FOLDER);
    String _plus_2 = (_plus_1 + "/");
    XMAComponent _xmaComponent = comp.getXmaComponent();
    String _namClass = _xmaComponent.getNamClass();
    String _plus_3 = (_plus_2 + _namClass);
    String _xifexpression = null;
    if (generated) {
      _xifexpression = "Gen";
    } else {
      _xifexpression = "";
    }
    String _plus_4 = (_plus_3 + _xifexpression);
    String _plus_5 = (_plus_4 + ".java");
    return _plus_5;
  }
  
  public String toJavaFilePath(final String qualifiedName) {
    String _filePath = this.toFilePath(qualifiedName, "java");
    return _filePath;
  }
  
  public String toFilePath(final String qualifiedName, final String fileExtension) {
    String _replaceAll = qualifiedName.replaceAll("\\.", "/");
    String _plus = (_replaceAll + ".");
    String _plus_1 = (_plus + fileExtension);
    return _plus_1;
  }
  
  public String toResourceBundleFilePath(final Component comp) {
    XMAComponent _xmaComponent = comp.getXmaComponent();
    String _namPackageAsPath = _xmaComponent.getNamPackageAsPath();
    String _plus = (_namPackageAsPath + "/");
    XMAComponent _xmaComponent_1 = comp.getXmaComponent();
    String _namClass = _xmaComponent_1.getNamClass();
    String _plus_1 = (_plus + _namClass);
    String _plus_2 = (_plus_1 + ".properties");
    return _plus_2;
  }
  
  public String backingBeanFileName(final EObject page, final boolean generated) {
    if (page instanceof XmadslPage) {
      return _backingBeanFileName((XmadslPage)page, generated);
    } else if (page instanceof Component) {
      return _backingBeanFileName((Component)page, generated);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(page, generated).toString());
    }
  }
}
