package org.openxma.dsl.generator.impl;

import org.eclipse.emf.ecore.EObject;
import org.openxma.dsl.pom.model.CheckBox;
import org.openxma.dsl.pom.model.Combo;
import org.openxma.dsl.pom.model.Component;
import org.openxma.dsl.pom.model.ListBox;
import org.openxma.dsl.pom.model.TableColumn;
import org.openxma.dsl.pom.model.TableCombo;
import org.openxma.dsl.pom.model.Text;
import org.openxma.dsl.pom.model.XmadslPage;

import com.google.inject.ImplementedBy;

@ImplementedBy(JsfNamesImpl.class)
public interface JsfNames {

    String getBackingBeanVar(Combo t);
    String getBackingBeanVar(ListBox lb);
    String getBackingBeanVar(Text t);
    String getBackingBeanVar(CheckBox b);
    String getBackingBeanVar(TableCombo tc);
    
    CharSequence getBean(XmadslPage page);

    CharSequence getDialogWidgetVar(XmadslPage page);

    Component component(XmadslPage page);

    XmadslPage mainPage(Component component);

    CharSequence getJSClass(EObject page);

    CharSequence getWidgetVar(EObject page);

    CharSequence referencedBean(EObject page);
    
    public abstract XmadslPage getParentPage(final EObject container);

    public abstract XmadslPage getParentPage(final TableColumn tableColumn);
    
    String getFaceletName(String n);
    
    String getFaceletPageName(XmadslPage dslPage, boolean generated);
    
    CharSequence toFaceletId(EObject o);
    CharSequence toFaceletFormId(XmadslPage page);

}